package cn.ibizlab.assetmanagement.core.asset.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.assetmanagement.core.asset.domain.EAMAssetStateModel;
import cn.ibizlab.assetmanagement.core.asset.filter.EAMAssetStateModelSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EAMAssetStateModel] 服务对象接口
 */
public interface IEAMAssetStateModelService extends IService<EAMAssetStateModel>{

    boolean create(EAMAssetStateModel et) ;
    void createBatch(List<EAMAssetStateModel> list) ;
    boolean update(EAMAssetStateModel et) ;
    void updateBatch(List<EAMAssetStateModel> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EAMAssetStateModel get(String key) ;
    EAMAssetStateModel getDraft(EAMAssetStateModel et) ;
    boolean checkKey(EAMAssetStateModel et) ;
    boolean save(EAMAssetStateModel et) ;
    void saveBatch(List<EAMAssetStateModel> list) ;
    Page<EAMAssetStateModel> searchDefault(EAMAssetStateModelSearchContext context) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<EAMAssetStateModel> getEamassetstatemodelByIds(List<String> ids) ;
    List<EAMAssetStateModel> getEamassetstatemodelByEntities(List<EAMAssetStateModel> entities) ;
}


